/*
 * 쐬: 2005/01/01
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package agent.communication;

import agentspace.AgentIdentifier;
import agentspace.Context;
import agentspace.Message;
import agentspace.Mobile;
import agentspace.event.AgentEvent;

/**
 * @author Ichiro Satoh
 *
 * TODO ̐ꂽ^Rg̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
public class Callee implements Mobile {
	String name;
	String result = "";
	public Callee() {
		name = "Callee";
	}

	public void create(AgentEvent evt, Context context) {
		System.out.println("Callee: method create() called");
		communicate(context);
	}
	public void destroy(AgentEvent evt, Context context) {
		System.out.println("Callee: method destroy() called");
	}
	public void suspend(AgentEvent evt, Context context) {
		System.out.println("Callee: method suspend() called");
	}
	public void resume(AgentEvent evt, Context context) {
		System.out.println("Callee: method resume() called");
	}
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("Callee: method arrive() called");
		communicate(context);
	}
	public void leave(AgentEvent evt, Context context) {
		System.out.println("Callee: method leave() called");
	}

	public void communicate(Context context) {
		AgentIdentifier[] aids = context.getAgents();
		for (int i = 0 ; i < aids.length ; i++) {
			if (aids[i].equals(context.getIdentifier())) {
				continue;
			}
			System.out.println("Callee: neighboring("+i+")'s aid = "+aids[i]);
			try {
				Message msg = new Message("hello");
				msg.setArg(name);
				Object obj = context.invoke(aids[i], msg);
				if (obj != null && obj instanceof String) {
					String message = (String)obj; 
					result = result + message + " from "+ aids[i] + "\n";
					System.out.println("Callee: "+result);
				}
			}
			catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}
}
